/* $Id: clavi.java,v 1.7 2012/02/04 06:09:05 mit Exp $
/* clavi.java v0.0 */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class clavi extends Applet 
    implements Runnable, ActionListener, AdjustmentListener
{
    private Panel PS;
    private Button btGo;
    private Button btStop;
    private Scrollbar scrVal;
    private Label lbVal;
    private Thread th;

    static double D = 5.0;  // ưΥ[mm]
    static double T = 0.01; // ư[sec]
    static int DEV = 40;    // ʬ

    boolean Runsw;
    int W;
    int H;
    int H2;
    int DOT = 4;
    int SFT = DOT/2;
    int LOOP;
    int VAL = 90;      // (ޤʤ)
    double DT = T/VAL; // Dʬ
    double DD;         // DEV
    double DH;         // ǡΨ
    double[] X0;
    double[] X1;
    double[] X2;

    Graphics gi;
    Image ig;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());

	PS = new Panel();
        PS.setLayout(new GridLayout(2,2,0,0));

        btGo = new Button("GO");
        PS.add(btGo);
        btGo.addActionListener(this);

        btStop = new Button("Stop");
        PS.add(btStop);
        btStop.addActionListener(this);

	scrVal = new Scrollbar(Scrollbar.HORIZONTAL, VAL,10,40,130);
        PS.add(scrVal);
        scrVal.addAdjustmentListener(this);

	lbVal = new Label(": Value ___");
	PS.add(lbVal);

        add(PS, "South");
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
	H2 = (int)(3.0*H/4.0);

        ig = createImage(W, H);
        gi = ig.getGraphics();
	DD = W/(double)DEV;
	DH = H2/10.0;

	X0 = new double[DEV];
	X1 = new double[DEV];
	X2 = new double[DEV];

	set_label();

	if (th == null) {
	    LOOP = 0;

            th = new Thread(this);
            th.start();
        }
    }
    public Dimension getCanvasD() {
        Dimension ds = PS.getSize();
        Dimension da = getSize();
        int cw = da.width;
        int ch = da.height-ds.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void run() {
	while(!Runsw) {
            try {
		LOOP++;
		if (LOOP > Integer.MAX_VALUE)
		    LOOP = 0;

		repaint();
                th.sleep(50);
            } 
            catch (InterruptedException e) {
                System.out.println(e);
            }
        }
    }
    public void stop() {
        if (th != null) {
            th = null;

	    LOOP = 0;
	}
    }
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btStop)
	    Runsw = true;
        else if (e.getSource() == btGo) {
            Runsw = false;
            th = null;
            start();
        }
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        if (e.getSource() == scrVal) {
	    VAL = scrVal.getValue();

	    DT = T/VAL;
	    set_label();

	    repaint();
	}
    }
    public void set_label() {
	lbVal.setText(": Value "+VAL);
    }
    //
    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
        paintI();
        g.drawImage(ig, 0, 0, this);
    }
    public void paintI() {
        gi.setColor(Color.black);
        gi.fillRect(0, 0, W, H);

	double dt = DT*LOOP;
	if (dt > T) {
	    X1[0] = X2[0] = D;
	} else {
	    X1[0] = X2[0] = D-D*Math.pow((dt/T-1), 2);
	}
	disp_tangent(gi);
	disp_line(gi);

	double x;
	gi.setColor(Color.green);
	for (int i = 0; i < DEV; i++) {
	    if (i < 1)
		x = X2[0];
	    else if (i >= DEV-1)
		x = 0;
	    else
		x = calc_wire(i);

	    X2[i] = x;
	    gi.fillOval((int)(DD*i+SFT), (int)(H2-DH*x), DOT, DOT);
	}

	System.arraycopy(X1, 0, X0, 0, DEV);
	System.arraycopy(X2, 0, X1, 0, DEV);
    }
    public double calc_wire(int l) {
	return X1[l-1]+X1[l+1]-X0[l];
    }
    public void disp_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2+SFT, W, H2+SFT); // ʿ

	g.drawLine(SFT, (int)(H2-DH*X2[0]+SFT),
		   (int)(DD*(DEV-1)+SFT), (int)(H2-X2[DEV-1]+SFT));
    }
    public void disp_tangent(Graphics g) {
	double h = DH*X2[0];

	g.setColor(Color.lightGray);
	g.fill3DRect(0, (int)(H2-h+DOT), DOT*2, (int)(H-h), true);
    }
}